var shorthandMap = require('./shorthand-map');
var hyphenate = require('./hyphenate-style-name');

module.exports = function warnMixedProperties(stylesObject) {
  var hyphenated = {};
  Object.keys(stylesObject).forEach(function (prop) {
    if (typeof stylesObject[prop] === 'string') {
      hyphenated[hyphenate(prop)] = prop;
    }
    // TODO: handle nested
  });
  Object.keys(hyphenated).forEach(function (prop) {
    var match = shorthandMap[prop];
    if (match) {
      // TODO: maybe change this to an array?
      for (key in match) {
        if (hyphenated[key]) {
          var original = hyphenated[prop];
          var problem = hyphenated[key];
          console.error(("Warning: both \"" + original + "\" and \"" + problem + "\" are used in style object: " + (JSON.stringify(stylesObject)) + ". Mixing of shorthand and longform properties is unsupported and may result in unexpected style behavior. You may want to use the https://lostyle.js.org/global.html#" + prop + " helper function to convert from shorthand to longform properties."));
        }
      }
    }
  });
}
